<?php
#!/usr/local/bin/php
// This is a loosely working script that provides a serial port for Arduino using PHP. 
// This project was made possible through support from the Canada Council for the Arts.
// For more information, please see www.brokencitylab.org
 

//BASIC START TO USING THIS SCRIPT 

include "php_serial.class.osx.php";

// Let's start the class
$serial = new phpSerial; 

// First we must specify the device. 
$serial->deviceSet("/dev/cu.usbserial-A900aetR"); 
//$serial->deviceSet("/dev/tty.usbserial-FTT37XA1"); 
sleep(2);
// We can change the baud rate, depending on what rate the Arduino is set
$serial->confBaudRate(9600); 

sleep(2);

// Then we need to open it
$serial->deviceOpen(); 
sleep(2);

// Please note that the various sources of text below need to be crudely commented out depending on what you want to use


///---------------------------------------------------------------------//

//SEND A PLAIN OL' MESSAGE FROM A VARIABLE
$message = "Windsor is divided. Originally a series of small towns spread along the Detroit River, Windsor is now amalgamated as one big dysfunctional place.";


//READ TEXT FROM A FILE
function pc_randomint($max = 1) { //basically just pulls a random line from the text file
	$m = 1000000;
	return ((mt_rand(1,$m * $max)-1)/$m);
	}

while ($x <5){
$line_number = 0;
$fh = fopen('yourFilenameHere.txt', 'r') or die($php_errormsg);

while (!feof($fh)){
if ($s = fgets($fh)){}
	$line_number++;
	if (pc_randomint($line_number) < 1) {
	$line = $s;
	$message = $line;
	$message = rtrim($message);
	$message = "leading text:" . $message; // adds some "leading text:" to the start of each line
	}
}




/// READS FROM AN RSS FEED (such as Twitter), uses Magpie RSS!

$rssitems = 20;
$x = 0;
while ($x < $rssitems){


require_once('rss_fetch.inc');
	$url = "http://search.twitter.com/search.atom?q=%23windsor";
	

$rss = fetch_rss( $url );

if ($rss) {

 $items = array_slice($rss->items, 0, $rssitems);
 
 foreach ($items as $item) {
	
	
		$title = $item['title'];
		
		
		$message = ">" . $title; // just adds a starting character to identify a new RSS entry
		
///---------------------------------------------------------------------//				

// REMOVES LINKS FROM THE STRING, USEFUL FOR PARSING TWEETS
	$message = preg_replace('/\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|$!:,.;]*[A-Z0-9+&@#\/%=~_|$]/i', '...', $message);
	$message = strip_tags($message);
// TRIES TO REMOVE UNFRIENDLY CHARACTERS	
	$message = str_ireplace("|", "", $message);
	$message = str_ireplace("\\", "", $message);
	$message = str_ireplace("\n", " ", $message);
	$message = str_ireplace("\r", " ", $message);

	$message = preg_replace ("/([^\s]{15,})/e", "''.wordwrap('\\1', 14,
' ', 1).''", $message);
//} // <<---- uncomment that closing bracket at the end of this mess to go through entire RSS feed.






// really rough disemvoweler - Mar 23, 2010, more of an example than a complete idea
if (strstr($message, 'fuck') OR strstr($message,'shit')){
$message = str_ireplace('fuck', 'fck', $message);
$message = str_ireplace('shit', 'sht', $message);
$message = str_ireplace('asshole', 'sshl', $message);
$message = str_ireplace('ass', 'ss', $message);

$message = str_ireplace('bitch', 'btch', $message);

}


//cut the message length to 160 characters
$message = substr($message,0,160);

// $message = myTruncate($message, 140, " "); 


//we're going to wrap each line at 20 characters and then send a * for new line
//the * tells the Arduino LCD to start a new line
$wrapped = wordwrap($message, 20, "*");


//number of characters in string
$length = (strlen($wrapped));
echo "<br /><br />number of characters is:". $length ."<br />";

//number of new lines
$newlines = substr_count($wrapped, "*");
echo "number of newlines is: " .$newlines . "<br />";

// number of words in total string
$wlength = str_word_count($wrapped);
echo "number of words is:" . $wlength . "<br />";


$pages = ceil(($newlines / 3.7)); /// MAR 22 - rounding up through Ceiling is important!

echo "OFFSET" . $offset = ceil($wlength * $pages) . "<br />";

//what am i trying to find - the number for the offset of characters  for the next page

//find the 5th newline, this should be the start of the page split
$nextpage = strpos($wrapped, "*" , 59); // the number at the end needs to adjust depending on how big the words are, because this looks for where the page splits should be and if the number isn't close, it won't paginate correctly
echo "location of the 5th newline is:" . $nextpage . "<br />";

echo "how many new pages:" .$pages. "<br /><br />";

$message = wordwrap($message, $nextpage, "*");


///---------------------------------------------------------------------//


// Clear the LCD
$serial->sendMessage("|");
$i = 0;
// if the length of the string is less than 80, it should be able to fit on 1 screen
if ($length <= 80){

// this is just for testing, spit out the string wrapped on the html page
echo str_ireplace("*", "<br />", $wrapped);

//send the message to the Serial port
$serial->sendMessage($wrapped);

//leave it on the LCD screen for 10 seconds
sleep(10);
}



// otherwise if the string is larger than 80 characters ...
else if ($length > 80) {
//start the counter
$i = 0;


// while the counter is less than or equal to the number of pages above
while ($i < $pages) {

// split the string into an array, 0 = first page, 1 = second page
$split = str_split($wrapped,($nextpage+1)); 

//we're going to wordwrap again so nothing gets left behind
$wrap[$i] = wordwrap($split[$i],($nextpage+1));


//send the message over serial
$serial->sendMessage($wrap[$i]);

//print is on html page
echo str_ireplace("*", "<br />", $wrap[$i]);

//this makes it so that the LCD will continue to print fluidly, takes 5 sec to print LCD
if($i < ($pages-1)){
echo "<br /><br />";
sleep (5);
}
// this makes it so that if we've reached the second page, the LCD holds for 10 seconds

else if ($i == ($pages-1)){
sleep(10);
}

//this clears the LCD
$serial->sendMessage("|");
$i++;

}}


}

} } //<<----- this needs to be commented out to make it just loop once

///---------------------------------------------------------------------//

// If you want to change the configuration, the device must be closed
$serial->deviceClose(); 
/* } */
 

 
// etc...
?>